function [] = pattern(shape,scale,iter)
    siz = size(shape);
    row = siz(1);
    col = siz(2);
    v = zeros(row^scale,col^scale);

    %v = iterate(v,iter);
    %imshow(v);
    
    for go = 1:iter
        v = iterate(v,go);
        imshow(v);
        saveas(gcf, ['pattern',sprintf('%03d',go),'.png'])
    end

    function out = iterate(in,iter)
        insiz = size(in);
        nr = insiz(1)/row;
        nc = insiz(2)/col;
        out = ones(insiz);
        if iter == 0
            out = in;
            return;
        end
        if insiz == size(shape)
            out = shape;
        else
            next = iterate(zeros(nr,nc),iter-1);
            for i = 1:row
                for j = 1:col
                    out((i-1)*nr+1:i*nr,(j-1)*nc+1:j*nc) = ~shape(i,j)*next+shape(i,j);
                end
            end
        end
    end
end