function [] = sierpinski(scale,i)
    v = zeros(3^scale);
    v = iterate(v,i);
    imshow(v);
    
    %for j = 1:i
    %    v = iterate(v,j);
    %    imshow(v);
    %    pause(1);
    %end

    function out = iterate(in,i)
        s = length(in)/3;
        out = ones(s*3);
        if i == 0
            out = in;
            return;
        end
        if s == 1
            out = [0 0 0 ; 0 1 0 ; 0 0 0];
        else
            %next = zeros(s);
            next = iterate(zeros(s),i-1);
            out(1:s,1:s) = next; % 7
            out(s+1:2*s,1:s) = next; % 4
            out(2*s+1:3*s,1:s) = next; % 1
            out(1:s,s+1:2*s) = next; % 8
            out(s+1:2*s,s+1:2*s) = 1; % 5
            out(2*s+1:3*s,s+1:2*s) = next; % 2
            out(1:s,2*s+1:3*s) = next; % 9
            out(s+1:2*s,2*s+1:3*s) = next; % 6
            out(2*s+1:3*s,2*s+1:3*s) = next; % 3
        end
    end
end